cf1739 D 二分,贪心

题意:https://codeforces.com/contest/1739/problem/D

思路:首先很显然我们要二分去求答案,那么我们考虑如何check,首先如果我们从上往下去切的操作数是大于等于从下往上切的,所以我们从下往上切,一旦该顶点的子树最大高度大于二分值,那么我们就切一刀,然后该点高度-二分值。

/*keep on going and never give up*/
#include<cstdio>
#include<iostream>
#include<queue>
#include<algorithm>
using namespace std;
#define int long long
typedef pair<int, int> pii;
#define lowbit(x) x&(-x)
#define endl '\n'
#define wk is zqx ta die
vector<int> pl[200005];
int dep[200005];
int n, k;
int sum = 0, res = 0;
int cost;
void dfs(int x, int fa) {
	int mx = 0;
	for (auto g : pl[x]) {
		if (g == fa) {
			continue;
		}
		dfs(g, x);
		mx = max(mx, dep[g]);
	}
	dep[x] = mx + 1;
	if (dep[x] >= cost && fa != 1 && x != 1) {
		res++;
		dep[x] -= cost;
	}
}
bool check(int x) {
	cost = x;
	res = 0;
	dfs(1, 0);
	if (res <= k) {
		return true;
	} else {
		return false;
	}
}
signed main() {
	std::ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	while (t--) {
		cin >> n >> k;
		for (int i = 1; i <= n; i++) {
			pl[i].clear();
		}
		for (int i = 2; i <= n; i++) {
			int fa;
			cin >> fa;
			pl[fa].push_back(i);
		}
		int l = 1;
		int r = n;
		int ans;
		while (l <= r) {
			int mid = (l + r) >> 1;
			if (check(mid)) {
				ans = mid;
				r = mid - 1;
			} else {
				l = mid + 1;
			}
		}
		cout << ans << endl;
	}
	return 0;
}

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值